-- p2.py: P2 Mhs definitions


-- @(#) $Header: /cs/research/pp/hubris/pp-beta/Format/p2explode/RCS/p2.py,v 5.0 90/09/20 16:00:49 pp Exp Locker: pp $
--
-- $Log:	p2.py,v $
-- Revision 5.0  90/09/20  16:00:49  pp
-- rcsforce : 5.0 public release
-- 
--



P2 DEFINITIONS IMPLICIT TAGS ::=

BEGIN

InformationObject ::=
	CHOICE {
            ipm[0] IPM,

            ipn[1] IPN
        }


-- IP-message UAPDU

IPM ::=
        SEQUENCE {
            heading
                Heading,

            body
                Body
        }


-- heading

Heading ::=
	ANY

-- body

Body ::=
        SEQUENCE OF BodyPart

BodyPart ::=

        CHOICE {
            ia5-text		[0] IA5TextBodyPart,

            tlx			[1] TLXBodyPart,

            voice		[2] VoiceBodyPart,

            g3-facsimile	[3] G3FacsimileBodyPart,

            g4-class1		[4] G4Class1BodyPart,

            teletex		[5] TeletexBodyPart,

            videotex		[6] VideotexBodyPart,

            encrypted		[8] EncryptedBodyPart,

            message		[9] MessageBodyPart,

            sfd			[10] SFDBodyPart,

            mixed-mode		[11] MixedModeBodyPart,

	    bilaterally-defined	[14] BilaterallyDefinedBodyPart,

            nationally-defined	[7] NationallyDefinedBodyPart,

	    externally-defined	[15] ExternallyDefinedBodyPart,

            odif		[12] ODIFBodyPart,

	    iso6937Text		[13] ISO6937TextBodyPart
        }


-- body part types

IA5TextBodyPart ::= SEQUENCE {
		parameters   IA5Parameters,
		data	     IA5TextData
		}

IA5Parameters ::= SET {
	      repertoire [0] Repertoire DEFAULT ia5
	      }

IA5TextData ::= IA5String

Repertoire ::= ENUMERATED {
	   ita2 (2),
	   ia5	(5)
	   }

TLXBodyPart ::= SEQUENCE OF ANY --84 and don't know what to do with it

VoiceBodyPart ::= SEQUENCE {
	      parameters   ANY,
	      data	   ANY}

G3FacsimileBodyPart ::= SEQUENCE {
		    parameters	 ANY,
		    data	 ANY}

G4Class1BodyPart ::= SEQUENCE OF ANY

MixedModeBodyPart ::= SEQUENCE OF ANY

TeletexBodyPart ::= SEQUENCE {
		parameters   ANY,
		data	     ANY}

VideotexBodyPart ::= SEQUENCE {
		 parameters	ANY,
		 data		ANY}	

EncryptedBodyPart ::= SEQUENCE {
		  parameters   ANY,
		  data	       ANY}

MessageBodyPart ::= SEQUENCE {
		parameters	MessageParameters,
		data		MessageData
		}

MessageParameters ::= SET {
		  delivery-time		[0] MessageDeliveryTime OPTIONAL,
		  delivery-envelope	[1] ANY OPTIONAL
		  }

MessageDeliveryTime ::= Time

MessageData ::= IPM

SFDBodyPart ::= SEQUENCE OF ANY

ODIFBodyPart ::=
        -- from appendix A minutes of the PODA Munich meeting July 6th 1988.
	        OCTET STRING

ISO6937TextBodyPart ::= SEQUENCE {
		    parameters	 ANY,
		    data	 ANY}

--ISO6937TextBodyPart ::= SEQUENCE {
--		       parameters   ISO6937Parameters,
--		       data	    ISO6937Data}

--ISO6937Parameters ::= SET {
--		  repertoire [0] IMPLICIT INTEGER {
--			     part1and2 (0),
--			     teletexSubRepertoire (3)}
--			     }
--		  }

--ISO6937Data :: = SEQUENCE OF ISO6937Line

--ISO6937Line ::= [0] IMPLICIT OCTET STRING

BilaterallyDefinedBodyPart ::= OCTET STRING

NationallyDefinedBodyPart ::= ANY

ExternallyDefinedBodyPart ::= SEQUENCE {
			  parameters   ANY,
			  data	       ANY}

-- IPN

IPN ::= SET {
	-- common-fields -- COMPONENTS OF CommonFields,

	choice [0] EXPLICIT CHOICE {
	       non-receipt-fields	[0]	NonReceiptFields,
	       receipt-fields		[1]	ReceiptFields
	       }
	}
RN ::= IPN -- with receipt-fields chosen

NRN ::= IPN -- with non-receipt-fields chosen

CommonFields ::= SET {
	subject-ipm			SubjectIPMField,
	ipn-originator		[1]	IPNOriginatorField OPTIONAL,
	ipm-preferred-recipient	[2]	IPNPreferredRecipientField OPTIONAL,
	conversion-eits			ConversionEITsField OPTIONAL
	}

NonReceiptFields ::= SET {
	non-receipt-reason	[0]	NonReceiptReasonField,
	discard-reason		[1]	DiscardReasonField OPTIONAL,
	auto-forward-comment	[2]	AutoForwardCommentField OPTIONAL,
	returned-ipm		[3]	ReturnedIPMField OPTIONAL
	}

ReceiptFields ::= SET {
	receipt-time  		[0] 	ReceiptTimeField,
	acknowledgment-mode	[1]	AcknowledgmentModeField DEFAULT manual,
	suppl-receipt-info	[2] 	SupplReceiptInfoField DEFAULT ""
	}

-- Common fields

SubjectIPMField ::= IPMIdentifier

IPMIdentifier ::= [APPLICATION 11] SET OF ANY

IPNOriginatorField ::= ORDescriptor

IPNPreferredRecipientField ::= ORDescriptor

ORDescriptor ::= SET OF ANY

ConversionEITsField ::= EncodedInformationTypes

EncodedInformationTypes ::= [APPLICATION 5] SET {
        built-in-encoded-information-types [0] ANY,
        external-encoded-information-types [4] ANY OPTIONAL }

-- Non-receipt fields

NonReceiptReasonField ::= ENUMERATED {
	ipm-discarded		     	(0),
	ipm-auto-forward		(1)
	}

DiscardReasonField ::= ENUMERATED {
	ipm-expired		  	(0),
	ipm-obsoleted			(1),
	user-subscription-terminated	(2)
	}

AutoForwardCommentField ::= AutoForwardComment

AutoForwardComment ::= PrintableString
	(SIZE (0..ub-auto-forward-comment))

ReturnedIPMField ::= IPM

-- Receipt fields

ReceiptTimeField ::= Time

AcknowledgmentModeField ::= ENUMERATED {
	manual			       (0),
	automatic		       (1)
	}

-- SupplReceiptInfoField ::= SupplementaryInformation

SupplReceiptInfoField ::= PrintableString
	(SIZE (1..ub-supplementary-info-length))

Time ::= UTCTime

END
