/* set_1dr.c: Do the necessary stuff to mark one recip as needing a DR */

# ifndef lint
static char Rcsid[] = "@(#)$Header: /cs/research/pp/hubris/pp-beta/Lib/pp/RCS/set_1dr.c,v 5.0 90/09/20 16:11:29 pp Exp Locker: pp $";
# endif

/*
 * $Header: /cs/research/pp/hubris/pp-beta/Lib/pp/RCS/set_1dr.c,v 5.0 90/09/20 16:11:29 pp Exp Locker: pp $
 *
 * $Log:	set_1dr.c,v $
 * Revision 5.0  90/09/20  16:11:29  pp
 * rcsforce : 5.0 public release
 * 
 */



#include "util.h"
#include "adr.h"
#include "q.h"
#include "dr.h"
#include "retcode.h"
#include <isode/cmd_srch.h>

extern char		*ppversion;
extern CMD_TABLE	rr_tcode[],
			rr_dcode[],
			rr_rcode[];

#define gval(x)                 ((x -> ad_type) == AD_X400_TYPE ? \
                                        (x -> ad_r400adr) : (x -> ad_r822adr))

int set_all_dr (qp, ap, reason, diag, str)
Q_struct *qp;
ADDR	*ap;
int	reason, diag;
char	*str;
{
	char	sdl, boundadd[BUFSIZ];
	
	for (; ap; ap = ap -> ad_next)
		if (set_1dr(qp, ap -> ad_no, 
			    reason, diag, str) == NOTOK)
			return NOTOK;
}

int set_1dr (qp, no, reason, diag, str)
Q_struct *qp;
int	no;
int	reason, diag;
char	*str;
{
	ADDR	*ap;
	char 	*argv[100];
	int	argc;
	char buffer[BUFSIZ];
	LIST_RCHAN	*lastchan;
	static char *eq = "=";

	for (ap = qp -> Raddress; ap; ap = ap -> ad_next) {
		if (ap -> ad_no == no)
			break;
	}

	if (ap == NULLADDR) {
		PP_LOG (LLOG_EXCEPTIONS, ("set_1dr: address %d not found",
					  no));
		return NOTOK;
	}

	ap -> ad_status = AD_STAT_DRREQUIRED;

	ap -> ad_reason = reason;
	ap -> ad_diagnostic = diag;
	ap -> ad_add_info = (str == NULLCP) ? NULLCP : strdup(str);

	argc = 0;
	argv[argc ++] = "DR";
	if (reason == DRR_NO_REASON)
		argv[argc++] = "positive";
	else	argv[argc++] = "negative";

	argv[argc++] = eq;
	argv[argc++] = "inchan";
	argv[argc++] = qp->inbound->li_chan->ch_name;

	argv[argc++] = eq;
	argv[argc++] = "dr_dest";
	argv[argc++] = gval(qp->Oaddress);

	argv[argc++] = qp->inbound->li_mta;

	argv[argc++] = eq;
	argv[argc++] = "outchan";
	if (ap -> ad_outchan && ap -> ad_outchan -> li_chan)
		argv[argc++] = ap->ad_outchan->li_chan->ch_name;
	else
		argv[argc++] = "none";

	argv[argc++] = eq;
	argv[argc++] = "dr-src";
	argv[argc++] =  gval(ap);

	if (ap -> ad_outchan && ap -> ad_outchan -> li_mta)
		argv[argc++] = ap->ad_outchan->li_mta;
	else
		argv[argc++] = "none";

	lastchan = ap -> ad_fmtchan;
	if (ap->ad_rcnt != 0) {
		int i = 0;
		while (i < ap->ad_rcnt && lastchan != NULLIST_RCHAN) {
			i++;
			lastchan = lastchan->li_next;
		}
	}			
	if (lastchan == NULLIST_RCHAN)
		lastchan = ap->ad_outchan;
		
	argv[argc++] = eq;
	argv[argc++] = "cur-channel";
	if (lastchan && lastchan -> li_chan)
		argv[argc++] = lastchan->li_chan->ch_name;
	else	argv[argc++] = "submit";

	if (reason != DRR_NO_REASON) {
		argv[argc ++] = eq;
		argv[argc++] = "reason";
		argv[argc++] = rcmd_srch(reason, rr_rcode);

		argv[argc++] = eq;
		argv[argc++] = "diag";
		argv[argc++] = rcmd_srch (diag, rr_dcode);

		if (str)
			argv[argc++] = str;
	}
	argv[argc] = NULL;

	arg2vstr (0, sizeof buffer, buffer, argv);
	PP_STAT (("%s", buffer));
	return OK;
}
